package com.zcloud.controller.invoice;

import com.zcloud.controller.base.BaseController;
import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;
import com.zcloud.logs.LogAnno;
import com.zcloud.service.invoice.InvoiceManagerService;
import com.zcloud.util.DateUtil;
import com.zcloud.util.Jurisdiction;
import com.zcloud.util.ObjectExcelView;
import com.zcloud.util.Tools;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import java.util.*;

/**
 * 说明：发票管理
 * 作者：luoxiaobao
 * 时间：2021-03-23
 * 官网：www.zcloudchina.com
 */
@Controller
@RequestMapping("/invoicemanager")
public class InvoiceManagerController extends BaseController {

	@Autowired
	private InvoiceManagerService invoicemanagerService;

	/**新增
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/add")
	// @RequiresPermissions("invoicemanager:add")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "发票管理",instructionsOperate = "发票管理",instructionsType = "新增")
	public Object add() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("INVOICEMANAGER_ID", this.get32UUID());	//主键
		pd.put("ISDELETE", "0");	//是否删除
		pd.put("OPDATE", DateUtil.date2Str(new Date()));	//操作日期
		pd.put("OPUSER", Jurisdiction.getUsername());	//操作人
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
		invoicemanagerService.save(pd);
		map.put("result", errInfo);
		return map;
	}

	/**删除
	 * @param out
	 * @throws Exception
	 */
	@RequestMapping(value="/delete")
	// @RequiresPermissions("invoicemanager:del")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "发票管理",instructionsOperate = "发票管理",instructionsType = "删除")
	public Object delete() throws Exception{
		Map<String,String> map = new HashMap<String,String>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		invoicemanagerService.delete(pd);
		map.put("result", errInfo);				//返回结果
		return map;
	}

	/**修改
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/edit")
	// @RequiresPermissions("invoicemanager:edit")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "发票管理",instructionsOperate = "发票管理",instructionsType = "修改")
	public Object edit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		invoicemanagerService.edit(pd);
		map.put("result", errInfo);
		return map;
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	@RequestMapping(value="/list")
	// @RequiresPermissions("invoicemanager:list")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "发票管理",instructionsOperate = "发票管理",instructionsType = "列表")
	public Object list(Page page) throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String KEYWORDS = pd.getString("KEYWORDS");						//关键词检索条件
		if(Tools.notEmpty(KEYWORDS))pd.put("KEYWORDS", KEYWORDS.trim());
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
		page.setPd(pd);
		List<PageData>	varList = invoicemanagerService.list(page);	//列出InvoiceManager列表
		map.put("varList", varList);
		map.put("page", page);
		map.put("result", errInfo);
		return map;
	}

	 /**去修改页面获取数据
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/goEdit")
	// @RequiresPermissions("invoicemanager:edit")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "发票管理",instructionsOperate = "发票管理",instructionsType = "去修改页面获取数据")
	public Object goEdit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd = invoicemanagerService.findById(pd);	//根据ID读取
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}
	 /**去修改页面获取数据
		 * @param
		 * @throws Exception
		 */
		@RequestMapping(value="/gokpxx")
		@ResponseBody
		@LogAnno(menuType= "综合管理",menuServer= "发票管理",instructionsOperate = "发票管理",instructionsType = "去修改页面获取数据")
		public Object gokpxx() throws Exception{
			Map<String,Object> map = new HashMap<String,Object>();
			String errInfo = "success";
			PageData pd = new PageData();
			pd = this.getPageData();

			pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
			List<PageData>	varList =  invoicemanagerService.listAll(pd);	//根据ID读取
			map.put("pd", pd);
			map.put("varList", varList);
			map.put("result", errInfo);
			return map;
		}
	 /**批量删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/deleteAll")
	// @RequiresPermissions("invoicemanager:del")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "发票管理",instructionsOperate = "发票管理",instructionsType = "批量删除")
	public Object deleteAll() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String DATA_IDS = pd.getString("DATA_IDS");
		if(Tools.notEmpty(DATA_IDS)){
			String ArrayDATA_IDS[] = DATA_IDS.split(",");
			invoicemanagerService.deleteAll(ArrayDATA_IDS);
			errInfo = "success";
		}else{
			errInfo = "error";
		}
		map.put("result", errInfo);				//返回结果
		return map;
	}

	 /**导出到excel
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/excel")
	// @RequiresPermissions("toExcel")
	@LogAnno(menuType= "综合管理",menuServer= "发票管理",instructionsOperate = "发票管理",instructionsType = "导出到excel")
	public ModelAndView exportExcel() throws Exception{
		ModelAndView mv = new ModelAndView();
		PageData pd = new PageData();
		pd = this.getPageData();
		Map<String,Object> dataMap = new HashMap<String,Object>();
		List<String> titles = new ArrayList<String>();
		titles.add("企业名称");	//1
		titles.add("纳税人识别号");	//2
		titles.add("地址");	//3
		titles.add("手机");	//4
		titles.add("姓名");	//5
		titles.add("是否删除");	//6
		titles.add("操作日期");	//7
		titles.add("操作人");	//8
		titles.add("开户银行");	//9
		titles.add("开户行账号");	//10
		dataMap.put("titles", titles);
		List<PageData> varOList = invoicemanagerService.listAll(pd);
		List<PageData> varList = new ArrayList<PageData>();
		for(int i=0;i<varOList.size();i++){
			PageData vpd = new PageData();
			vpd.put("var1", varOList.get(i).getString("ENTERPRISENAME"));	    //1
			vpd.put("var2", varOList.get(i).getString("UCODE"));	    //2
			vpd.put("var3", varOList.get(i).getString("ADDRESS"));	    //3
			vpd.put("var4", varOList.get(i).getString("PHONE"));	    //4
			vpd.put("var5", varOList.get(i).getString("SNAME"));	    //5
			vpd.put("var6", varOList.get(i).getString("ISDELETE"));	    //6
			vpd.put("var7", varOList.get(i).getString("OPDATE"));	    //7
			vpd.put("var8", varOList.get(i).getString("OPUSER"));	    //8
			vpd.put("var9", varOList.get(i).getString("DEPOSITBANK"));	    //9
			vpd.put("var10", varOList.get(i).getString("ACCOUNTNUMBER"));	    //10
			varList.add(vpd);
		}
		dataMap.put("varList", varList);
		ObjectExcelView erv = new ObjectExcelView();
		mv = new ModelAndView(erv,dataMap);
		return mv;
	}

}
